#if	ELTYPES_H_INCLUDED
#else //ELTYPES_H_INCLUDED
	#define ELTYPES_H_INCLUDED	1

// factored out from pocket.h so that 
// p_cmp can use the types in the include file

typedef enum
	{
	APLNCHAR	=  0	// C APL "Narrow" CHAR
,	APLBOOL		=  1	// B
,	APLSINT		=  2	// S
,	APLINTG		=  3	// I
,	APLLONG		=  4	// L
,	APLDOUB		=  5	// D
,	APLPNTR		=  6	// P
,	APLWCHAR8	=  7	// U APL "Wide" CHAR (squeezed to 8 )
,	APLWCHAR16	=  8 	// V APL "Wide" CHAR (squeezed to 16)
,	APLWCHAR32	=  9 	// W APL "Wide" CHAR (squeezed to 32)

,	APLCMPX		= 10	// Z
,	APLRATS		= 11	// Q
,	APLDECF_DPD	= 12	// F IBM
,	APLDECF_BID	= 13	// G INTEL
				// |
				// `--- Character codes used in acc.c.

,	NELTYPES	= 14	// number of ELTYPEs.

#if HAS_UNICODE
,	APLCHAR8	= APLWCHAR8
,	APLCHAR		= APLWCHAR32
,	APLGUICHAR	= APLWCHAR	// in port.h, eltype for wchar_t
#else
,	APLCHAR8	= APLNCHAR
,	APLCHAR		= APLNCHAR
,	APLGUICHAR	= APLNCHAR
#endif

#if     HAS_APLDECF_DPD
	#define	HAS_APLDECF	1
,       APLDECF         = APLDECF_DPD
#elif   HAS_APLDECF_BID
	#define	HAS_APLDECF	1
,       APLDECF         = APLDECF_BID
#endif
	} APL_ELTYPE;

#endif//ELTYPES_H_INCLUDED
