#include	<machine.h>
#include	<windows.h>

#include	<apl.h>
#include	<support.h>
#include	<ap_dotnet.h>
#include	<vcclr.h>

#include	<string.h>

using namespace System;
using namespace System::Runtime::InteropServices;

__gc public class DyalogBridgeExample
{
public:

	Object *ConvertToArray(int n, String *s) __gc[]
		{
		BOUND bound=2;
		ARRAY *array = mkarray(APLPNTR,1,&bound);
		ARRAY **aptr = (ARRAY**)arraystart(array);

		bound = 1;
		aptr[0]=mkarray(APLLONG,0,&bound);
		*(aplint32*)arraystart(aptr[0])=n;

		bound=s->Length;
		aptr[1]=mkarray(APLWCHAR16,1,&bound);

		const wchar_t __pin* pinchars = PtrToStringChars(s);
		//pin_ptr<const wchar_t>pinchars = PtrToStringChars(s);
		memcpy(arraystart(aptr[1]),pinchars,bound*sizeof(aplWchar16));

		GCHANDLE i = 0;

		i=dotnet_ArrayToNet(array,0);

		//GCHandle h = static_cast<GCHandle>((IntPtr)i);
		GCHandle h =(GCHandle)GCHandle::op_Explicit(i);

		return static_cast<Object * __gc []>(h.Target);
		}

};
